#!/usr/bin/perl

$ForReading = 1;
$MaxLines = 50;

open(IN_H, "sample.txt");
open(OUT_H, "> testfile.txt");

print OUT_H "FastPDFGen\tDEMO.FASTLINUX::2019/01/17::B2D3C7C081E8C1661612269650F8B01F\n";
print OUT_H "compressField\n";
print OUT_H "start\tpdfgensample4_r.pdf\n";

$Counter = 1;
@Lines = ();
while (<IN_H>) {
    if (@Lines >= $MaxLines) {
        &PrintPage;
        @Lines = ();
    }
    chomp($_);
    push(@Lines, $_);
}

if (@Lines > 0) {
    &PrintPage;
}

print OUT_H "finish";
close(OUT_H);

system('../FastPDFGen_utf8 < testfile.txt');


sub PrintPage {
    $DrawPointX = 85;
    $DrawPointY = 135;
    $BoxWidth = 310;
    $LineHeight = 12;
    $HeaderHeight = 23;
    $DrawPointItem2 = 67;
    $DrawPointItem3 = 217;

    print OUT_H "startPage\tpdfgensample4.pdf.tpl\n";

    print OUT_H "drawBox\t" . $DrawPointX . "\t" . $DrawPointY . "\t" . $BoxWidth . "\t" . ($HeaderHeight + $LineHeight * @Lines + 1) . "\t0.6\t1\t0\t0\t0\n";

    print OUT_H "drawLine\t" . $DrawPointX . "\t" . ($DrawPointY + $HeaderHeight - 4) . "\t" . $BoxWidth . "\t0\t0.3\t1\t0\t0\t0\n";
    print OUT_H "drawLine\t" . $DrawPointX . "\t" . ($DrawPointY + $HeaderHeight - 2) . "\t" . $BoxWidth . "\t0\t0.3\t1\t0\t0\t0\n";

    for ($LineNo = 1; $LineNo < @Lines; $LineNo++) {
        print OUT_H "drawLine\t" . $DrawPointX . "\t" . ($DrawPointY + $HeaderHeight + $LineHeight * $LineNo) . "\t" . $BoxWidth . "\t0\t0.2\t1\t0\t0\t0\n";
    }

    print OUT_H "drawLine\t" . ($DrawPointX + $DrawPointItem2) . "\t" . $DrawPointY . "\t0\t" . ($HeaderHeight + $LineHeight * @Lines + 1) . "\t0.2\t1\t0\t0\t0\n";
    print OUT_H "drawLine\t" . ($DrawPointX + $DrawPointItem3) . "\t" . $DrawPointY . "\t0\t" . ($HeaderHeight + $LineHeight * @Lines + 1) . "\t0.2\t1\t0\t0\t0\n";

    print OUT_H "makeArrayPageField\titem1\t" . @Lines . "\t" . $LineHeight . "\n";
    print OUT_H "makeArrayPageField\titem2\t" . @Lines . "\t" . $LineHeight . "\n";
    print OUT_H "makeArrayPageField\titem3\t" . @Lines . "\t" . $LineHeight . "\n";

    print OUT_H "setPageFieldData\tdate\t2013/12/25\n";
    print OUT_H "setPageFieldData\ttitle1\tNo.\n";
    print OUT_H "setPageFieldData\ttitle2\t̾\n";
    print OUT_H "setPageFieldData\ttitle3\t\n";

    for($LineNo = 0; $LineNo < @Lines; $LineNo++) {
        $DispLineNo = $LineNo + 1;
        ($name, $date) = split(/,/, $Lines[$LineNo]);
        print OUT_H "setPageFieldData\titem1__" . $DispLineNo . "\t" . $Counter . "\n";
        print OUT_H "setPageFieldData\titem2__" . $DispLineNo . "\t" . $name . "\n";
        print OUT_H "setPageFieldData\titem3__" . $DispLineNo . "\t" . $date . "\n";
        $Counter++;
    }

    print OUT_H "endPage\n";
}
